unit MQueryEd;

{$I mODBC.INC}

interface

{$IFDEF DELPHI4}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls,db,mquery,DsgnIntf;

type
  TQueryEditDlg = class(TForm)
    Panel1: TPanel;
    Panel5: TPanel;
    OKButton: TButton;
    CancelButton: TButton;
    HelpButton: TButton;
    PageControl1: TPageControl;
    OptionsTabSheet: TTabSheet;
    GroupBox1: TGroupBox;
    Panel9: TPanel;
    Label2: TLabel;
    TableNameComboBox: TComboBox;
    GetTableFieldsButton: TButton;
    DatasetDefaultsButton: TButton;
    GetPrimaryKeysButton: TButton;
    SQLTabSheet: TTabSheet;
    StatementTypeRadioGroup: TRadioGroup;
    Panel14: TPanel;
    SqlMemo: TMemo;
    Panel15: TPanel;
    Panel2: TPanel;
    SelectPanel: TPanel;
    Panel17: TPanel;
    KeyPanel: TPanel;
    Panel13: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Panel3: TPanel;
    FieldsListBox: TListBox;
    KeyFieldsListBox: TListBox;
    UpdateFieldsListBox: TListBox;
    AllFieldsCheckBox: TCheckBox;
    QuoteFieldNamesCheckBox: TCheckBox;
    GenerateSQLButton: TButton;
    ResetDatabaseButton: TButton;
    procedure TableNameComboBoxChange(Sender: TObject);
    procedure TableNameComboBoxDropDown(Sender: TObject);
    procedure GenerateSQLButtonClick(Sender: TObject);
    procedure Panel2Resize(Sender: TObject);
    procedure TableNameComboBox1DropDown(Sender: TObject);
    procedure GetTableFieldsButtonClick(Sender: TObject);
    procedure GetPrimaryKeysButtonClick(Sender: TObject);
    procedure StatementTypeRadioGroupClick(Sender: TObject);
    procedure SQLTabSheetEnter(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure DatasetDefaultsButtonClick(Sender: TObject);
    procedure ResetDatabaseButtonClick(Sender: TObject);
    procedure OKButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SqlMemoChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    SQLGenerated:boolean;
    function fnutt(const s:string):String;
  public
    FMquery:Tmquery;
    { Public declarations }
  end;

  TmQueryEditor = class(TComponentEditor)
  private
  protected
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure Edit;override;
  end;
var
  QueryEditDlg: TQueryEditDlg;

procedure ShowQueryDlg(AQuery: TmQuery);

implementation
{$R *.DFM}

uses
   DSDesign;


procedure ShowQueryDlg(AQuery: TmQuery);
begin
   if (AQuery <> nil) then begin
       QueryEditDlg:=TQueryEditDlg.Create(Application);
       try
           QueryEditDlg.FMquery:=Tmquery.Create(QueryEditDlg);
           QueryEditDlg.FMquery.DataBase:=AQuery.DataBase;
           QueryEditDlg.FMquery.DataSource:=AQuery.DataSource;
           QueryEditDlg.FMquery.DeleteSQL:=AQuery.DeleteSQL;
           QueryEditDlg.FMquery.InsertSQL:=AQuery.InsertSQL;
           QueryEditDlg.FMquery.ModifySQL:=AQuery.ModifySQL;
           QueryEditDlg.FMquery.SQL:=AQuery.SQL;
           if QueryEditDlg.ShowModal = mrOK then begin
               AQuery.DataBase.DataBaseName:=QueryEditDlg.FMquery.DataBase.DataBaseName;
               AQuery.DeleteSQL:=QueryEditDlg.FMquery.DeleteSQL;
               AQuery.InsertSQL:=QueryEditDlg.FMquery.InsertSQL;
               AQuery.ModifySQL:=QueryEditDlg.FMquery.ModifySQL;
               AQuery.SQL:=QueryEditDlg.FMquery.SQL;
           end;
       finally
           QueryEditDlg.FMquery.Destroy;
           QueryEditDlg.Free;
       end;
   end;
end;

function TQueryEditDlg.fnutt(const s: string): String;
begin
   if QuoteFieldNamesCheckBox.checked then begin
       result:='"'+s+'"';
   end else begin
       result:=s;
   end;
end;

procedure TQueryEditDlg.TableNameComboBoxChange(Sender: TObject);
begin
   FMquery.DataBase.GetColumnNames(TableNameComboBox.text,FieldsListBox.Items);
end;

procedure TQueryEditDlg.TableNameComboBoxDropDown(Sender: TObject);
begin
   FMquery.DataBase.GetTableNames(TableNameComboBox.Items);
end;

procedure TQueryEditDlg.GenerateSQLButtonClick(Sender: TObject);
var
   i:integer;
   ts:tstringlist;
begin
(*
General behaviour is :
add all fieldnames to ts,
insert commas,
send all items in ts to the "real" Tstring
*)
   ts:=tstringlist.Create;
   if (FieldsListBox.selcount=0) and  (AllFieldsCheckBox.Checked=false) then begin
       ts.add('No Fields selected for "select" query');
   end;
   if (KeyFieldsListBox.selcount=0) then begin
       ts.add('No Primary key fields selected');
   end;
   if (UpdateFieldsListBox.selcount=0) then begin
       ts.add('No Update fields selected');
   end;
   if ts.count>0 then begin
       ts.add('Continue Anyway ?');
       If windows.MessageBox(0,PChar(ts.Text),'Warning',mb_okcancel)=idCancel then begin
           exit;
       end;
   end;

   SQLGenerated:=true;
//   FMquery.sql.BeginUpdate;
//   FMquery.sql.Clear;
//   FMquery.sql.Add('SELECT ');

   ts.Clear;
   ts.Add('SELECT ');
   if AllFieldsCheckBox.checked then begin
       ts.add('  * ');
   end else begin
       for i:=0 to FieldsListBox.Items.Count-1 do begin
           if FieldsListBox.Selected[i] then begin
               ts.add('  '+fnutt(FieldsListBox.Items[i]));
           end;
       end;
       for i:=1 to ts.Count-2 do begin
           ts[i]:= ts[i]+',';
       end;
   end;
   ts.add('FROM '+fnutt(TableNameComboBox.text));

   FMquery.SQL.Assign(ts);
//   For i:=0 to ts.Count-1 do begin
//       FMquery.sql.add(ts[i]);
//   end;
//   FMquery.sql.EndUpdate;

//Update query generation

   FMquery.ModifySQL.BeginUpdate;
   FMquery.ModifySQL.Clear;
   FMquery.ModifySQL.add('update '+fnutt(TableNameComboBox.text));
   FMquery.ModifySQL.add('set ');
   ts.clear;
   For i:=0 to UpdateFieldsListBox.items.Count-1 do begin
     if UpdateFieldsListBox.Selected[i] then //Added this to make it work, JB
       ts.add(fnutt(UpdateFieldsListBox.items[i])+' = :'+UpdateFieldsListBox.items[i]);
   end;
   For i:=0 to ts.count-2 do begin
       ts[i]:=ts[i]+',';
   end;
   FMquery.ModifySQL.AddStrings(ts);
//   For i:=0 to ts.Count-1 do begin
//       FMquery.ModifySQL.add(ts[i]);
//   end;
   FMquery.ModifySQL.add('Where ');
   ts.clear;
   For i:=0 to KeyFieldsListBox.items.Count-1 do begin
       if KeyFieldsListBox.Selected[i] then begin
           ts.add(fnutt(KeyFieldsListBox.items[i])+' = :OLD_'+KeyFieldsListBox.items[i]);
       end;
   end;
   For i:=0 to ts.count-2 do begin
       ts[i]:=ts[i]+' and';
   end;
   For i:=0 to ts.Count-1 do begin
       FMquery.ModifySQL.add(ts[i]);
   end;
   FMquery.ModifySQL.EndUpdate;

//INSERT query generation
   ts.Clear;
   For i:=0 to UpdateFieldsListBox.items.Count-1 do begin
       if UpdateFieldsListBox.Selected[i] then  //Added this to make it work, JB
       ts.add(fnutt(UpdateFieldsListBox.items[i]));
   end;
   For i:=0 to ts.count-2 do begin
       ts[i]:=ts[i]+',';
   end;
   FMquery.InsertSQL.BeginUpdate;
   FMquery.InsertSQL.Clear;
   FMquery.InsertSQL.add('insert into '+fnutt(TableNameComboBox.text));
   FMquery.InsertSQL.add('(');
   For i:=0 to ts.Count-1 do begin
       FMquery.InsertSQL.add(ts[i]);
   end;
   FMquery.InsertSQL.add(')');
   FMquery.InsertSQL.add('values ');
   FMquery.InsertSQL.add('(');
   For i:=0 to ts.count-1 do begin
       ts[i]:=':'+ts[i];
   end;
   FMquery.InsertSQL.AddStrings(ts);
//   For i:=0 to ts.Count-1 do begin
//       FMquery.InsertSQL.add(ts[i]);
//   end;
   FMquery.InsertSQL.add(')');
   FMquery.InsertSQL.EndUpdate;

// delete query
   ts.Clear;
   For i:=0 to KeyFieldsListBox.items.count-1 do
       if KeyFieldsListBox.Selected[i] then
           ts.add(fnutt(KeyFieldsListBox.items[i])+' = :OLD_'+KeyFieldsListBox.items[i]);
   For i:=0 to ts.count-2 do
       ts[i]:=ts[i]+' and';
   FMquery.DeleteSQL.BeginUpdate;
   FMquery.DeleteSQL.Clear;
   FMquery.DeleteSQL.add('delete from '+fnutt(TableNameComboBox.text));
   FMquery.DeleteSQL.add('where');

   FMquery.DeleteSQL.AddStrings( ts);
//   For i:=0 to ts.Count-1 do begin
//       FMquery.DeleteSQL.add(ts[i]);
//   end;
   FMquery.DeleteSQL.EndUpdate;
   ts.free;
   PageControl1.ActivePage:=SQLTabSheet;
end;

procedure TQueryEditDlg.ResetDatabaseButtonClick(Sender: TObject);
begin
   SQLGenerated:=false;
   FMquery.DataBase.DisConnect;
   TableNameComboBox.Text:='';
   FieldsListBox.Items.Clear;
   KeyFieldsListBox.Items.Clear;
   UpdateFieldsListBox.Items.Clear;
end;


procedure TQueryEditDlg.Panel2Resize(Sender: TObject);
begin
   SelectPanel.width:=Panel2.width div 3;
   KeyPanel.width:=SelectPanel.width;
end;

procedure TQueryEditDlg.TableNameComboBox1DropDown(Sender: TObject);
begin
   FMquery.DataBase.GetTableNames(TableNameComboBox.Items);
end;

procedure TQueryEditDlg.GetTableFieldsButtonClick(Sender: TObject);
begin
   if TableNameComboBox.text='' then begin
       raise exception.create('Must Specify a Table name');
   end else begin
       FMquery.DataBase.GetColumnNames(TableNameComboBox.text,UpdateFieldsListBox.Items);
       KeyFieldsListBox.items:=UpdateFieldsListBox.Items;
       FieldsListBox.items:=UpdateFieldsListBox.Items;
   end;
end;

procedure TQueryEditDlg.GetPrimaryKeysButtonClick(Sender: TObject);
var
   ts:tstringlist;
   i:integer;
begin
   ts:=tstringlist.Create;
   FMquery.DataBase.GetPrimaryKeys(TableNameComboBox.text,ts);
   for i := 0 to KeyFieldsListBox.items.count-1 do begin
       KeyFieldsListBox.Selected[i]:=
           ts.IndexOf(KeyFieldsListBox.items[i])<>-1
   end;
   ts.free;
end;


procedure TQueryEditDlg.StatementTypeRadioGroupClick(Sender: TObject);
begin
   Case StatementTypeRadioGroup.ItemIndex of
       0:SqlMemo.Lines:=FMquery.SQL;
       1:SqlMemo.Lines:=FMquery.ModifySQL;
       2:SqlMemo.Lines:=FMquery.InsertSQL;
       3:SqlMemo.Lines:=FMquery.DeleteSQL;
   end;
end;

procedure TQueryEditDlg.SQLTabSheetEnter(Sender: TObject);
begin
   StatementTypeRadioGroupClick(Sender);
end;


procedure TQueryEditDlg.PageControl1Change(Sender: TObject);
begin
   if assigned(PageControl1.ActivePage.OnEnter)then begin
       PageControl1.ActivePage.OnEnter(Sender);
   end;
end;

procedure TQueryEditDlg.FormActivate(Sender: TObject);
begin
   if assigned(PageControl1.OnChange)then begin
       PageControl1.OnChange(Sender);
   end;
end;


procedure TQueryEditDlg.DatasetDefaultsButtonClick(Sender: TObject);
var
   i:integer;
begin
   GetTableFieldsButtonClick(Sender);
   GetPrimaryKeysButtonClick(Sender);
   AllFieldsCheckBox.checked:=true;
   for i:=0 to UpdateFieldsListBox.Items.Count-1 do begin
       UpdateFieldsListBox.Selected[i]:=true;
   end;
end;

procedure TQueryEditDlg.OKButtonClick(Sender: TObject);
begin
   if not SQLGenerated then begin
       If windows.MessageBox(0,'You have not generated any Sql! '#13'Continue Anyway ?','Warning',mb_okcancel)=idCancel then begin
           modalresult:=mrnone;
       end;
   end;
end;

procedure TQueryEditDlg.FormCreate(Sender: TObject);
begin
   SQLGenerated:=false;
end;

procedure TQueryEditDlg.SqlMemoChange(Sender: TObject);
begin
   SQLGenerated:=true;
end;


function TmQueryEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

function TmQueryEditor.GetVerb(Index: Integer): string;
begin
   case index of
       0: Result := 'Fields E&ditor';
       1: Result := '&mQuery Editor ...';
       else Result := '';
  end;
end;

procedure TmQueryEditor.ExecuteVerb(Index: Integer);
begin
   case index of
       0:  begin
               DSDesign.ShowDatasetDesigner(Designer, TDataSet(Component));
               Designer.Modified;
           end;
       1: begin
               edit;
           end;
   end;
end;


procedure TmQueryEditor.Edit;
begin
   ShowQueryDlg(TmQuery(Component));
end;
{$ELSE}
implementation
{$ENDIF}
end.
